/**
 * This class represents a user that has name score and some cards
 *
 * @Zahra_SeyedFateho
 * @version0.0
 */

import java.util.ArrayList;
import java.util.Objects;

public class User {
    private String name;
    private int score;
    private ArrayList<Card> userCards;

    /**
     * create a user
     */
    public User( String name){
        userCards = new ArrayList<>();
        score = 0;
        this.name = name;
    }

    public User() {

    }

    /**
     * remove a card from user cards
     */
    public void addCard(Card card){
        userCards.add(card);
    }

    /**
     * @return user name
     */
    public String getName() {
        return name;
    }

    /**
     * at the end of the game returns the score of user
     * @return score field
     */
    public int getScore() {
        score = 0;
        for (Card card : userCards ){
         score += card.getScore();
        }
        return score;
    }

    /**
     * @param users list of users
     * @param chosenUser is current user
     * @return chosen user
     */
    public User pass(ArrayList<User> users , User chosenUser){
        if (users.indexOf(chosenUser) + 1 == users.size()){
            return users.get(0);
        }
        else
        return users.get(users.indexOf(chosenUser) + 1);
    }

    /**
     * @return the list of user cards
     */
    public ArrayList<Card> getUserCards() {
        return userCards;
    }

    /**
     * show the order of players and chosen user cards
     * @param users is the list of users
     */
    public void printCards(ArrayList<User> users){
        for (int i = 0 ; i < users.size() ; i++){
            System.out.println(users.get(i).getName()+ "=====>>"+users.get(i).getUserCards().size());
        }
        System.out.println("TURN IS FOR "+ name +"  YOUR CARDS ARE");
        System.out.println("enter the number of your card for example : 3");
        int counter = 1;
        for (Card card : userCards){
            System.out.println(counter);
            card.print();
            counter++;
        }
    }
    
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof User)) return false;
        User user = (User) o;
        return getScore() == user.getScore() &&
                getName().equals(user.getName()) &&
                userCards.equals(user.userCards);
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName(), getScore(), userCards);
    }
}
